%define _x11man1dir	%_x11mandir/man1
%define _pixmapsdir	%_datadir/pixmaps
%define _switchdir	%_x11libdir/drv.d

%define drvs	modules/drivers
%define dris	modules/dri
%define lnxs	modules/linux
%define ati_rel 1

Name: fglrx_glx
Version: 8.18.6
Release: alt1
Summary: ATI drivers for Radeon and Fire GL
Group: System/Kernel and hardware

URL: http://www.ati.com/
License: Proprietary

Provides: libGL
Provides: x11-driver-fglrx

Source0: http://www2.ati.com/drivers/linux/fglrx_6_8_0-%version-%ati_rel.i386.rpm
#Source1: http://www2.ati.com/drivers/linux/fglrx64_6_8_0-%version-%ati_rel.x86_64.rpm
Source2: fglrx-switch

Source10: fireglcontrol.menu

Patch1: fglrx-3.11.1-fglrx_gamma.patch

Patch100: fglrx-3.2.8-agp-sis.patch
Patch101: fglrx-3.2.8-via-agp2.patch
Patch102: fglrx-3.2.8-nvidia-nforce.patch
Patch103: fglrx-3.7.6-agp-sis-fix.patch
Patch104: fglrx-3.7.6-sis-agp3-support.patch

Patch112: fglrx-8.10.19-module_param-2.6.x-warn_cleanup.patch
#Patch113: fglrx-8.10.19-pte_unmap-2.4-warn_cleanup.patch

#Patch114: fglrx-8.4.13-alt-amd64.patch

Requires: xorg-x11-server >= 6.8.0, hardware >= 0.2

# libglx-x11.a from mesagl is required
Requires: xorg-x11-mesagl >= 6.8.2-alt9

# Automatically added by buildreq on Sun Jan 30 2005
BuildRequires: cpio fontconfig freetype2 gcc-c++ libqt3-devel libstdc++-devel xorg-x11-devel xorg-x11-libs

BuildPreReq: kernel-build-tools
#ExclusiveArch: %ix86 x86_64
ExclusiveArch: %ix86

%description 
Proprietary ATI drivers for Radeon and Fire GL cards.

%package -n fglrx-tools
Summary: Utilities for ATI Radeon and Fire GL drivers
Group: System/Configuration/Hardware
Requires: %name = %version-%release

%description -n fglrx-tools
ATI FireGL/Radeon configuration utilities:

fireglcontrol is [intended to be] a full-blown ATI graphics card
configuration panel similar to those in Microsoft(R) Windows(TM).

fglrxinfo is an analogue for glxinfo.

fglrxconfig is a replacement for xf86config. NOTE: USE WITH CAUTION!!!
This tool will erase your current XF86Config without making a backup
copy!

fglrx_xgamma is a small tool to adjust gamma.

%package -n kernel-source-fglrx-%version
Summary: Linux fglrx (Radeon/Fire GL video card driver) module sources
Group: Development/Kernel

%description -n kernel-source-fglrx-%version
fglrx (Radeon/Fire GL video card driver) module sources for Linux kernel.

%prep
%setup -T -c
#ifarch %ix86
rpm2cpio %SOURCE0 | %__cpio -idmv --no-absolute-filenames --no-preserve-owner
#else
#rpm2cpio %SOURCE1 | %__cpio -idmv --no-absolute-filenames --no-preserve-owner
#endif
%setup -D -T

pushd lib/modules/fglrx/build_mod
%__rm -f make.sh
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch112 -p0
#patch113 -p0
#patch114 -p1
find . -type f -name '*.orig' -delete
cd ..
%__mv build_mod kernel-source-fglrx-%version
%__tar -cj -f ../../../kernel-source-fglrx-%version.tar.bz2 \
	kernel-source-fglrx-%version
popd

%__mkdir fglrx_panel
pushd fglrx_panel
%__tar -xz -f ../usr/src/ATI/fglrx_panel_sources.tgz
# Comment out QApplication::setStyle - it don't work anyway
%__subst 's/QApplication::setStyle/\/\/QApplication::setStyle/' main.cpp

popd

%__mkdir fglrx_tools
pushd fglrx_tools
%__tar -xz -f ../usr/src/ATI/fglrx_sample_source.tgz
%patch1 -p1 -b .fglrx_gamma
popd

%setup -D -T

# remove precompiled fglrxcontrol binaries
%__rm -f usr/X11R6/bin/*.bz2

%build
#chrpath -d usr/X11R6/bin/* usr/X11R6/%_lib/*.so* usr/X11R6/%_lib/modules/*/*.so*

pushd fglrx_panel
%make QTDIR=/usr/%_lib/qt3 \
	LIBS="-L/usr/%_lib/qt3/lib -lqt -L/usr/X11R6/%_lib -lXxf86vm"
popd

pushd fglrx_tools/lib/fglrx_gamma
xmkmf
%make
%__rm -f libfglrx_gamma.so*
popd

pushd fglrx_tools/programs/fglrx_gamma
xmkmf
%make
popd



%install
%set_strip_method executable,shared
%set_verify_elf_method textrel=relaxed,rpath=strict

%__mkdir_p %buildroot%_x11bindir
%__mkdir_p %buildroot%_x11libdir/%drvs
%__mkdir_p %buildroot%_x11libdir/%dris
%__mkdir_p %buildroot%_x11libdir/%lnxs
%__mkdir_p %buildroot%_x11libdir/fglrx
%__mkdir_p %buildroot%_x11includedir/X11/extensions
%__mkdir_p %buildroot%_x11man1dir
%__mkdir_p %buildroot%_menudir
%__mkdir_p %buildroot%_iconsdir
%__mkdir_p %buildroot%_pixmapsdir

%__mkdir_p %kernel_srcdir

%__install -p -m644 usr/X11R6/%_lib/%drvs/fglrx_drv.o \
	%buildroot%_x11libdir/%drvs/
%__install -p -m644 usr/X11R6/%_lib/%dris/atiogl_a_dri.so \
	%buildroot%_x11libdir/%dris/
%__install -p -m644 usr/X11R6/%_lib/%dris/fglrx_dri.so \
	%buildroot%_x11libdir/%dris/
%__install -p -m644 usr/X11R6/%_lib/%lnxs/libfglrxdrm.a \
	%buildroot%_x11libdir/%lnxs/

%__install -p -m644 usr/X11R6/%_lib/libGL.so.1.2 \
	%buildroot%_x11libdir/fglrx/libGL.so.1
%__install -p -m644 usr/X11R6/%_lib/libfglrx_pp.so.1.0 \
	%buildroot%_x11libdir
#%__install -p -m644 usr/X11R6/%_lib/*gamma* %buildroot%_x11libdir/
#%__install -p -m644 usr/X11R6/include/X11/extensions/fglrx_gamma.h \
#	%buildroot%_x11includedir/X11/extensions/

pushd fglrx_tools/programs/fglrx_gamma
%__make install DESTDIR=%buildroot
popd

%__install -p usr/X11R6/bin/fgl_glxgears	%buildroot%_x11bindir/
%__install -p usr/X11R6/bin/fglrxconfig		%buildroot%_x11bindir/
%__install -p usr/X11R6/bin/fglrxinfo		%buildroot%_x11bindir/
%__install -p usr/X11R6/bin/aticonfig		%buildroot%_x11bindir/
%__install -p fglrx_panel/fireglcontrol		%buildroot%_x11bindir/
#%__install -p fglrx_tools/programs/fglrx_gamma/fglrx_xgamma \
#	%buildroot%_x11bindir/
#%__install -p -m644 fglrx_tools/programs/fglrx_gamma/fglrx_xgamma.man \
#	%buildroot%_x11man1dir/fglrx_xgamma.1
%__install -p -m644 fglrx_panel/ati.xpm %buildroot%_iconsdir/
%__install -p -m644 fglrx_panel/ati.xpm %buildroot%_pixmapsdir/
%__install -p -m644 %SOURCE10 %buildroot%_menudir/fireglcontrol

%__install -p -m644 kernel-source-fglrx-%version.tar.bz2 %kernel_srcdir/

%__mkdir -p %buildroot%_switchdir
%__install -p -m755 %SOURCE2 %buildroot%_switchdir/fglrx
%__subst 's,@X11LIBDIR@,%_x11libdir,g' %buildroot%_switchdir/fglrx

%post
%post_ldconfig

%postun
%postun_ldconfig

%post -n fglrx-tools
%update_menus

%postun -n fglrx-tools
%clean_menus

%files
%_x11libdir/%drvs/*
%_x11libdir/%lnxs/*
%_x11libdir/%dris/*
%_x11libdir/fglrx
%_x11libdir/libfglrx_pp.*
#%_x11libdir/*gamma*
#%attr(0644,root,root) %_x11includedir/X11/extensions/*
%doc usr/share/doc/fglrx/*
%_switchdir/*

%files -n fglrx-tools
%_x11bindir/*
%_iconsdir/*
%_pixmapsdir/*
%_menudir/*
#%_x11man1dir/*

%files -n kernel-source-fglrx-%version
%_usrsrc/*

%changelog
* Sun Oct 16 2005 LAKostis <lakostis at altlinux.ru> 8.18.6-alt1
- Version 8.18.6.
- Removed patches:
  - fglrx-8.10.19-pte_unmap-2.4-warn_cleanup.patch
- Disable x86_64 support.

* Wed Jun 29 2005 Anton D. Kachalov <mouse@altlinux.org> 8.14.13-alt2
- Added x86_64 support

* Sat Jun 11 2005 Sergey Vlasov <vsu@altlinux.ru> 8.14.13-alt1
- Version 8.14.13.
- Removed obsolete 2.6.11-compatibility patches:
  - fglrx-8.10.19-agp_backend-2.6.11rc2.patch
  - fglrx-8.10.19-i386-warn_cleanup.patch
  - fglrx-8.10.19-rage3d_4-level-pagetables.patch
  - fglrx-8.10.19-remap_page_range-2.6.11rc1.patch
- Added Provides: x11-driver-fglrx (#6597).
- Updated fglrx-switch script for the new libglx name (libglx-x11.a); added
  dependency on xorg-x11-mesagl >= 6.8.2-alt9 for this file.

* Tue Jun 07 2005 Sergey Vlasov <vsu@altlinux.ru> 8.12.10-alt3
- Moved libGL.so.fglrx to %_x11libdir/fglrx (fixes #6065).

* Tue Jun 07 2005 Anton Farygin <rider@altlinux.ru> 8.12.10-alt2
- added script for setgl (%_switchdir/fglrx)

* Wed Jun 01 2005 Sergey Vlasov <vsu@altlinux.ru> 8.12.10-alt1
- Version 8.12.10.

* Sun Mar 13 2005 Sergey Vlasov <vsu@altlinux.ru> 8.10.19-alt1
- Version 8.10.19.
- Removed patches:
  - fglrx-8.8.25-kernel-2.6.10.patch (obsolete)
- Added patches for compatibility with kernel 2.6.11:
  + fglrx-8.10.19-agp_backend-2.6.11rc2.patch: add compatibility with new AGP
    layer in 2.6.11 (drm_agp_t was removed)
  + fglrx-8.10.19-i386-warn_cleanup.patch: remove x86_64-only functions and
    variables from the i386 build
  + fglrx-8.10.19-module_param-2.6.x-warn_cleanup.patch: use new-style module
    parameters for 2.6.x instead of obsolete MODULE_PARM
  + fglrx-8.10.19-pte_unmap-2.4-warn_cleanup.patch: #undef pte_unmap before
    redefining it to be empty
  + fglrx-8.10.19-rage3d_4-level-pagetables.patch: add support for 4-level page
    tables in 2.6.11
  + fglrx-8.10.19-remap_page_range-2.6.11rc1.patch: use new remap_pfn_range
    function instead of obsolete remap_page_range which was removed in 2.6.11

* Sun Jan 30 2005 Sergey Vlasov <vsu@altlinux.ru> 8.8.25-alt2
- Added patches for kernel module parts (moved here from kernel-modules-fglrx-*
  packages):
  + fglrx-3.2.8-agp-sis.patch: added SiS 745 host bridge IDs to the builtin AGP
    support
  + fglrx-3.2.8-via-agp2.patch: fixed AGP 2.0 support for VIA KT400 and P4X333
  + fglrx-3.2.8-nvidia-nforce.patch: fixed nForce AGP support
  + fglrx-3.7.6-agp-sis-fix.patch: workaround for SiS 648 and 746 chips (seems
    that they need a delay after setting AGP rate)
  + fglrx-3.7.6-sis-agp3-support.patch: AGP3 support for SiS 648
  + fglrx-8.8.25-kernel-2.6.10.patch: fix compilation with kernel 2.6.10
- Removed rpath cleaning (fixed upstream again).
- Updated Requires (this driver is for X.Org 6.8).
- Updated BuildRequires.

* Tue Jan 18 2005 LAKostis <lakostis at altlinux.ru> 8.8.25-alt1
- Version 8.8.25.

* Wed Jan 12 2005 LAKostis <lakostis at altlinux.ru> 3.14.6-alt1.1
- fix fglrx-panel to compile with new qt.

* Fri Nov 12 2004 LAKostis <lakostis at altlinux.ru> 3.14.6-alt1
- Daedalus build.
- Version 3.14.6.

* Fri Oct 01 2004 LAKostis <lakostis at altlinux.ru> 3.14.1-alt1
- Daedalus build.
- Version 3.14.1.

* Mon Aug 16 2004 Sergey Vlasov <vsu@altlinux.ru> 3.11.1-alt1
- Version 3.11.1.
- Added back rpath cleaning.
- Added fglrx_xgamma to fglrx-tools.
- Added documentation.

* Mon Mar 22 2004 Sergey Vlasov <vsu@altlinux.ru> 3.7.6-alt1
- Version 3.7.6.
- Removed rpath cleaning (fixed upstream).
- Added rpath=strict check.
- Updated BuildRequires.

* Sat Jan 03 2004 Sergey Vlasov <vsu@altlinux.ru> 3.7.0-alt1
- Version 3.7.0.
- Use the RPM from ATI as Source instead of a repacked tarball.
- Fixed file modes.
- Relaxed TEXTREL check.
- Merged with Alexey Morozov <morozov@altlinux> changes:
  - build both fglrx_glx and kernel-source-fglrx packages from the single
    official ATI driver rpm package
  - new driver version (3.7.0)
  - fglrx_panel and fglrx_gamma is built and packaged into
    fglrx-tools subpackage
- Excluded *fglrx_gamma* because of wrong soname in libfglrx_gamma.so.1.
- Added README file from the ATI site (not included in the original RPM).
- Updated BuildRequires.

* Sun Oct 12 2003 Sergey Vlasov <vsu@altlinux.ru> 3.2.8-alt1
- new version (3.2.8)

* Tue Sep 09 2003 Rider <rider@altlinux.ru> 3.2.5-alt1
- new version

* Wed Jul 16 2003 Peter Novodvorsky <nidd@altlinux.com> 2.9.12-alt1
- initial release.

